"use strict";

const config = require("../conf/config.json");

class mod {
    static onLoad() {
        
        const locations = LocationConfig

        for (const map in config.MaxLooseItemsRolled) {
            locations.limits[map] = config.MaxLooseItemsRolled[map]
        }
        
        let generateDynamicLoot = function generateDynamicLoot(dynamic, lootPositions, location) {
            let rndLootIndex = RandomUtil.getInt(0, dynamic.length - 1);
            let rndLoot = dynamic[rndLootIndex];

            if (!rndLoot.data)
            {
                // remove item from array and return error
                dynamic.splice(rndLootIndex, 1);
                return { "result": "error", "reason": "baddata" };
            }
    
            let rndLootTypeIndex = RandomUtil.getInt(0, rndLoot.data.length - 1);
            let data = rndLoot.data[rndLootTypeIndex];
    
            //Check if LootItem is overlapping
            let position = `${data.Position.x},${data.Position.y},${data.Position.z}`;
            if (!LocationConfig.allowLootOverlay && lootPositions.includes(position))
            {
                //Clear selected loot
                dynamic[rndLootIndex].data.splice(rndLootTypeIndex, 1);
    
                if (dynamic[rndLootIndex].data.length === 0)
                {
                    dynamic.splice(rndLootIndex, 1);
                }
    
                return { "status": "error", "reason": "duplicatelocation" };
            }
    
            //random loot Id
            data.Id = HashUtil.generate();
    
            //create lootItem list
            let lootItemsHash = {};
            let lootItemsByParentId = {};
    
            for (const i in data.Items)
            {
                // Check for the item spawnchance
                let loot = data.Items[i];
                lootItemsHash[loot._id] = loot;
    
                if (!("parentId" in loot))
                    continue;
    
                if (lootItemsByParentId[loot.parentId] === undefined)
                    lootItemsByParentId[loot.parentId] = [];
                lootItemsByParentId[loot.parentId].push(loot);
            }
    
            //reset itemId and childrenItemId
            for (const itemId of Object.keys(lootItemsHash))
            {
                let newId = HashUtil.generate();
                lootItemsHash[itemId]._id = newId;
    
                if (itemId === data.Root)
                    data.Root = newId;
    
                if (lootItemsByParentId[itemId] === undefined)
                    continue;
    
                for (const childrenItem of lootItemsByParentId[itemId])
                {
                    childrenItem.parentId = newId;
                }
            }
    
            const globalLootChanceModifier = config.GlobalLootMultiplier.value;
            const locationLootChanceModifier = RandomUtil.getFloat(config.MapLootMultiplier.min, config.MapLootMultiplier.max).toFixed(2);
            Logger.debug(locationLootChanceModifier);
            const num = RandomUtil.getInt(0, 100);
            const spawnChance = DatabaseServer.tables.templates.items[data.Items[0]._tpl]._props.SpawnChance;
            const itemChance = Math.round(spawnChance * globalLootChanceModifier * locationLootChanceModifier);
    
            if (itemChance >= num)
            {
                return { "status": "success", "data": data, "position": position };
            }
    
            return { "status": "error", "reason": "failedspawnchancecheck" }; // item spawn chance was lower than random number
            };

        LocationGenerator.generateDynamicLoot = generateDynamicLoot;
    }

}

module.exports = mod;